
/**
 * @package heiv-gallery_3
 * @author www.heiv.fr
 * @version 0.2.4
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.2.4
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010-2011 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
var CURRENT_ID=1;
var hg3_input_edited = new Array();

// closure to avoid namespace collision
(function(){
	// creates the plugin
	tinymce.create('tinymce.plugins.heiv_gallery_3', {
		// creates control instances based on the control's id.
		// our button's id is &quot;mygallery_button&quot;
		createControl : function(id, controlManager) {
			if (id == 'heiv_gallery_3_button') {
				// creates the button
				var button = controlManager.createButton('heiv_gallery_3_button', {
					title : 'Ajouter une gallery3', // title of the button
					image : '../wp-content/plugins/heiv-gallery-3/img/G3_LOGO.png',  // path to the button's image
					onclick : function() {

                                                var width = jQuery(window).width(), H = jQuery(window).height(), W = ( 720 < width ) ? 720 : width;
                                                W = W - 80;
                                                H = H - 84;
                                                tb_show( 'Gallery 3', '#TB_inline?width=' + W + '&height=' + H + '&inlineId=heiv_gallery_3_form' );
						populate_renderer();
						populate_dir(1);
					}
				});
				return button;
			}
			return null;
		}
	});

	// registers the plugin. DON'T MISS THIS STEP!!!
	tinymce.PluginManager.add('heiv_gallery_3', tinymce.plugins.heiv_gallery_3);

        jQuery(function(){
                // creates a form to be displayed everytime the button is clicked
                // you should achieve this using AJAX instead of direct html code like this
                var form = jQuery('<div id="heiv_gallery_3_form"><table id="heiv_gallery_3_form_table" class="form-table">\
			<tr>\
				<th><label for="heiv_gallery_3_render">Skin</label></th>\
				<td><select id="heiv_gallery_3_render" name="render"></select></td>\
			</tr>\
                        <tr>\
                                <td><div id="heiv_gallery_3_tree"><ul id="node_1" style="border:1px solid grey;height:300px;overflow:auto;padding:5px;"></ul></div></td>\
				<td><select onchange="heiv_gallery_3_change_page()" id="heiv_gallery_3_listing_page"></select><div id="heiv_gallery_3_listing" style="border:1px solid grey;width:350px;height:284px;overflow:auto;"><ul id="heiv_gallery_3_listing_ul" style="text-align:center;margin-top:10px;"></ul></div></td>\
                        </tr>\
		</table>\
		<input type="submit" id="mygallery-submit"/>\
	</div>');
	        
		var table = form.find('table');
        	form.appendTo('body').hide();
                form.find('#mygallery-submit').click(function(){

			var id = jQuery('li.heiv_gallery_3_selected');
			if(id.length==1){
				var options = {
					'show_caroussel'	: '',
					'text_caroussel'	: '',
					'height'		: '',
					'width'			: '',
					'direct_link'		: '',
					'timed'			: '',
					'delay'			: '',
					'info_pane'		: '',
					'render'		: ''
				};
				var id = id[0].id;
                        	var shortcode = '[hgallery3 ';
				var error = false;
				var msg = '';
				shortcode += 'id="'+id.replace("node_","")+'"';

				for( var index in options) {
					var value = null;
					switch(index) {
					// case boolean
						case 'direct_link':
						case 'info_pane':
						case 'timed':
						case 'show_caroussel':
							if(hg3_is_edited(index)){
								value = table.find('[name='+index+']').val();
								shortcode += ' ' + index + '="' + value + '"';
							}
							break;
					// case numeric
						case 'height':
						case 'width':
						case 'delay':
							value = jQuery.trim(table.find('#heiv_gallery_3_' + index).val());
							if(value!=''){
								var exp = new RegExp("^[0-9]+$","g");
								if(!exp.test(value)) {
									msg += index + " is not a number\n";
									error = true;
								}
								else
									shortcode += ' ' + index + '="' + value + '"';
							}
							break;
					// case text
						case 'render':
						case 'text_caroussel':
							value = jQuery.trim(table.find('#heiv_gallery_3_' + index).val());
							if(value!='')
								 shortcode += ' ' + index + '="' + value + '"';
							break;
					}
					value=null;
				}
        	                shortcode += ']';

                        // inserts the shortcode into the active editor
				if(error)
					alert(msg);
				else {
	                	        tinyMCE.activeEditor.execCommand('mceInsertContent', 0, shortcode);
					tb_remove();
				}
			}
		});
	})
})()

function populate_renderer() {
	var data = {
		action: 'heiv_gallery_3_get_renderer'
	};
	jQuery.post(ajaxurl, data, function(response) {
		var resp = JSON.parse(response);
		if(resp.error!=1){ 
			var select = jQuery("#heiv_gallery_3_render");
			select.html('');
			jQuery.each(resp.renderer,function (i,renderer) {
				select.append('<option value="'+renderer+'">'+renderer+'</option>');
			});
			select.val("smoothgallery");
		}
	});
}

function populate_dir(id) {
	var num_page = jQuery('#heiv_gallery_3_listing_page').val();
	if(num_page) {
//		num_page = new Number(num_page)-1
	}
	else {
		num_page=0;
	}
	var photos = {
		action: 'heiv_gallery_3_populate_photos',
		start: num_page,
		id: id
	};

	jQuery.post(ajaxurl, photos, function(response) {
		var resp = JSON.parse(response);
		if(resp.error!=1) {
			var page = jQuery('#heiv_gallery_3_listing_page');
			page.html('');
			for(var i=1;i<=resp.nb_pages;i++) {
				page.append('<option value="'+(i-1)+'">page '+i+'</option>');
			}

			var listing = jQuery('#heiv_gallery_3_listing_ul');
			listing.html('');
			jQuery.each(resp.photos, function (i,photo){
				listing.append('<li id="node_'+photo.id+'" id="node_'+photo.id+'"><a href="#" onclick="return heiv_gallery_3_select('+photo.id+',this)"><img id="heiv_gallery_3_img_'+photo.id+'" src="'+photo.thumb+'"/></a></li><li><hr/></li>');
			});
			page.val(resp.req_p);
		}
	});
	var data = {
		action: 'heiv_gallery_3_populate_tree',
		start: num_page,
		id:id 
	};
	jQuery.post(ajaxurl, data, function(response) {
		var resp = JSON.parse(response);
		if(resp.error!=1){
			var root = jQuery('#node_1');
			root.html('');
			if(resp.req!=1){
				root.append('<li class="node_up" id="node_'+resp.pid+'"><a href="#" onclick="return heiv_gallery_3_select('+resp.pid+',this)" ondblclick="return populate_dir('+resp.pid+')">..</a></li>');
			}
			jQuery.each(resp.members, function (i,member){
				switch(member.type){
					case 'album':
						root.append('<li id="node_'+member.id+'"><a href="#" onclick="return heiv_gallery_3_select('+member.id+',this)" ondblclick="return populate_dir('+member.id+',this)">'+member.title+'</a></li>');
					break;
				}
				
			});
			CURRENT_ID=resp.req;
		}
	});
}

function heiv_gallery_3_select(id,elem){
	jQuery('#node_1 li, #heiv_gallery_3_listing_ul li').css('background','none');
	jQuery('#node_1 li').removeClass('heiv_gallery_3_selected');
	jQuery('li#node_'+id).css('background','MistyRose');
	jQuery('li#node_'+id).addClass('heiv_gallery_3_selected');
	return false;
}

function heiv_gallery_3_change_page(){
	var num_page = jQuery('#heiv_gallery_3_listing_page').val();
//	alert(num_page);
	populate_dir(CURRENT_ID);
	return false;
}

function heiv_gallery_3_show_options(target){
	if(jQuery('table tr.options').css('display')=='none') {
		jQuery('table tr.options').css('display','');
		jQuery('a#show_options').text("Hide options");
	}
	else {
		jQuery('table tr.options').css('display','none');
		jQuery('a#show_options').text("Show options");
	}
	
}

function heiv_gallery_3_input_edited(input) {
	var find = false;
	for( var index in hg3_input_edited) {
		if(hg3_input_edited[index] == input){
			find = true;
			break;
		}
	}
	if(find) {
	}
	else {
		hg3_input_edited[hg3_input_edited.length] = input;
	}
}

function hg3_is_edited(input) {
	var find = false;
	for( var index in hg3_input_edited) {
		if(hg3_input_edited[index] == input){
			find = true;
			break;
		}
	}
	return find;
}
