<?php

/**
 * @package heiv-gallery_3
 * @author www.heiv.fr
 * @version 0.2.4
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.2.4
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010-2011 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

class heiv_gallery_3_render_dir extends heiv_gallery_3_render {
	protected $pattern_css_photo = '';
	protected $pattern_js_gallery= '';

	function heiv_gallery_3_render_dir($options=null,$attrs_=null) {

		$this->options = $options;

		extract(shortcode_atts(array(
			'target'=>'_blank',
			'direct_link' => $this->options['g3_directlink'] 
		), $attrs));

		$this->options['direct_link'] = $direct_link=='false' || $direct_link=='true' ? 
								$direct_link : 
								(isset($options['g3_directlink'])?$options['g3_directlink']:'false');
	}

	function get_render_album($info) {
		$request = $this->options['permalink'];
		$str_target='';
		if(strpos($request,'?')===FALSE) {
			$str_target='?target';
		}
		else {
			$str_target='&target';
		}
		return sprintf (
			'<span class="hg3_s_dir_alb"><a href="%3$s%10$s=%5$s&id=%4$d"><img src="%2$s" title="%1$s"/></a><div><a href="%3$s%10$s=%5$s&id=%4$d">%1$s</a></div><span class="info">%6$s %7$s, %8$d %9$s</span> </span>',
			$info->entity->slug,
			$info->entity->thumb_url_public,
			$request,
			$info->entity->id,
			$info->target,
			$info->entity->view_count,
			_n('view','views',$info->entity->view_count),
			sizeof($info->members),
			_n('item','items',$info->members),
			$str_target
		);
	}

	function get_render_photo( $info ) {
		return sprintf('<span class="hg3_s_dir_alb"><a rel="%6$s" href="%5$s" class="thickbox"><img src="%2$s" alt="%1$s"/></a><div><a href="%5$s" class="thickbox">%1$s</a></div><span class="info">%3$d %4$s</span></span>',
			$info->entity->title,
			$info->entity->thumb_url_public,
                        $info->entity->view_count,
                        _n('view','views',$info->entity->view_count),
			$info->entity->resize_url_public,
			$this->options['rdm_id']
		);
	}

	function get_render($infos) {
		return parent::get_render($infos,$this->options);
	}

	function register_wp_css() {
		wp_enqueue_style('heiv_gallery_3_render_dir', plugin_dir_url(__FILE__) . 'css/dir.css');
		wp_enqueue_style('thickbox');
	}

	function register_wp_js () {
		wp_enqueue_script('thickbox');
	}

	function get_js_gallery() {
		return sprintf( '
				<script type="text/javascript">
					function startGallery_%1$s() {
						$(\'gallery_%1$s\').className=\'gall\';
					}
					window.addEvent(\'domready\', startGallery_%1s);
				</script>'
				,$this->options['rdm_id']);
	}

	function get_css_photo() {
		return '';
		return sprintf( '
				<script type="text/javascript">
					function startGallery_%1$s() {
						$(\'gallery_%1$s\').style.width=\'300px;\';
					}//hehe
					window.addEvent(\'domready\', startGallery_%1s);
				</script>'
				,$this->options['rdm_id']);
	}
	public function get_form_conf () {
		return 'No configuration';
	}

}
?>
