<?php
/**
 * @package heiv-gallery_3
 * @author www.heiv.fr
 * @version 0.2.4
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.2.4
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010-2011 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

define('DEFAULT_WIDTH_CAROUSEL',75);
define('DEFAULT_SIZE',250);
define('DEFAULT_AUTO_INTEGER',1);
define('DEFAULT_SCROLL',0);

class heiv_gallery_3_render_jcarousel extends heiv_gallery_3_render {
	protected $pattern_css_photo = '';
	protected $pattern_js_gallery= '';

	function heiv_gallery_3_render_jcarousel($options=null,$attrs_=null) {

		$this->options = $options;

		extract(shortcode_atts(array(
			'target'=>'_blank',
			'scroll'=>0,
			'auto_integer'=>1,
			'skin' => 'tango',
			'width_carousel' => 75,
			'direct_link' => $this->options['g3_directlink'] 
		), $attrs_));

		$this->options['g3_jcarousel_scroll']=trim($this->options['g3_jcarousel_scroll']);
		$this->options['g3_jcarousel_auto_integer']=trim($this->options['g3_jcarousel_auto_integer']);

		$this->options['g3_jcarousel_scroll'] = !is_numeric($this->options['g3_jcarousel_scroll']) ? DEFAULT_SCROLL : $this->options['g3_jcarousel_scroll'];
		$this->options['g3_jcarousel_auto_integer'] = !is_numeric($this->options['g3_jcarousel_auto_integer']) ? DEFAULT_AUTO_INTEGER : $this->options['g3_jcarousel_auto_integer'];
		$this->options['g3_jcarousel_skin'] = trim($this->options['g3_jcarousel_skin']);
		$this->options['g3_jcarousel_width_carousel'] = trim($this->options['g3_jcarousel_width_carousel']);
		$this->options['g3_jcarousel_width_carousel'] = !is_numeric($this->options['g3_jcarousel_width_carousel'])? DEFAULT_WIDTH_CAROUSEL : $this->options['g3_jcarousel_width_carousel'];
		$this->options['g3_jcarousel_size'] = trim($this->options['g3_jcarousel_size']);
		$this->options['g3_jcarousel_size'] = !is_numeric($this->options['g3_jcarousel_size'])? DEFAULT_SIZE : $this->options['g3_jcarousel_size'];

		if(is_null($this->options['g3_jcarousel_skin'])){
			$this->options['g3_jcarousel_skin'] = $skin;
		}
	}

	function get_render_album($info) {
		return sprintf('<li><img src="%s"/></li>',$info->entity->thumb_url_public);
	}

	public function get_render_photo( $info ) {
		return sprintf('<li><a href="%1$s" class="thickbox" rel="%3$s"><img src="%2$s"/></a></li>',$info->entity->resize_url_public,$info->entity->thumb_url_public,$this->options['rdm_id']);
	}

	function get_render($infos) {
		return parent::get_render($infos,$this->options);
	}

	function register_wp_css() {
		wp_enqueue_style('heiv_gallery_3_render_jcarousel', plugin_dir_url(__FILE__) . 'skins/'.$this->options['g3_jcarousel_skin'].'/skin.css');
	}

	function register_wp_js () {
		wp_enqueue_script('heiv_gallery_3_render_jcarousel',plugin_dir_url(__FILE__).'jquery.jcarousel.min.js');
	}

	function get_js_gallery() {
		return sprintf( '
				<style type="text/css">
					#gallery_%1$s li img {
						width:%5$spx;
						height:%5$spx;
					}
					#gallery_%1$s .jcarousel-container-horizontal, #gallery_%1$s .jcarousel-clip-horizontal {
						width : %4$spx;
						height: %5$spx;
					}
					#gallery_%1$s .jcarousel-item {
						width:%5$spx;
						height:%5$spx;
					}
				</style>
				<script type="text/javascript">
					jQuery(document).ready(function() {
						jQuery(\'#gal_jcarou_%1$s\').jcarousel({
						        // Configuration goes here
							auto:%2$s,
							scroll:%3$s
						});
					});
				</script>
				',
				$this->options['rdm_id'],
				$this->options['g3_jcarousel_auto_integer'],
				$this->options['g3_jcarousel_scroll'],
				$this->options['g3_jcarousel_width_carousel'],
				$this->options['g3_jcarousel_size'],
				$this->options['g3_jcarousel_skin'],
				$this->options['g3_jcarousel_size']+2

		);
/**/
	}

	function get_css_photo() {
		return '';
/*
		return sprintf(' <style>

				</style>', $this->options['g3_jcarousel_skin'],$this->options['g3_jcarousel_size']
		);
*/
	}
	public function get_form_conf () {
		$ret = sprintf('
		<table class="form-table">
			<tr>
				<td>
					<label for="g3_jcarousel_auto_integer">Delay for the autoscroll</label>
				</td>
				<td>
					<input id="g3_jcarousel_auto_integer" type="text" size="40" maxlength="99" value="%s" name="g3_jcarousel_auto_integer" min="0" max="1000" required="required"/>
					<img id="help_jcarousel_auto_integer" class="ico_info" alt="(info)" src="#"/>
				</td>
			</tr>
			<tr>
				<td>
					<label for="g3_jcarousel_scroll">Number Items to scroll</label>
				</td>
				<td>
					<input id="g3_jcarousel_scroll" type="text" size="40" maxlength="99" value="%s" name="g3_jcarousel_scroll"/>
					<img id="help_jcarousel_scroll" class="ico_info" alt="(info)" src="#"/>
				</td>
			</tr>
			<tr>
				<td>
					<label for="g3_jcarousel_size">Size of the thumbnail images</label>
				</td>
				<td>
					<input id="g3_jcarousel_size" type="text" size="40" maxlength="99" value="%s" name="g3_jcarousel_size"/>
					<img id="help_jcarousel_size" class="ico_info" alt="(info)" src="#"/>
				</td>
			</tr>
			<tr>
				<td>
					<label for="g3_jcarousel_width_carousel">Width of the Carousel</label>
				</td>
				<td>
					<input id="g3_jcarousel_width_carousel" type="text" size="40" maxlength="99" value="%s" name="g3_jcarousel_width_carousel"/>
					<img id="help_jcarousel_width_carousel" class="ico_info" alt="(info)" src="#"/>
				</td>
			</tr>
			<tr>
				<td>
					<label for="g3_jcarousel_skin">Skin of jcarousel</label>
				</td>
				<td>
					<select id="g3_jcarousel_skin" val="%s" name="g3_jcarousel_skin"/>',
			$this->options['g3_jcarousel_auto_integer'],
			$this->options['g3_jcarousel_scroll'],
			$this->options['g3_jcarousel_size'],
			$this->options['g3_jcarousel_width_carousel'],
			$this->options['g3_jcarousel_skin']);
							$tmp_skins = $this->get_skins();
							foreach($tmp_skins as $skin) {
								$sel = $skin == $this->options['g3_jcarousel_skin']?'selected="selected"':'';
								$ret .= sprintf('<option value="%1$s" %2$s>%1$s</option>',$skin,$sel);
							}		
		$ret .= '					
					</select>
					<img id="help_jcarousel_skin" class="ico_info" alt="(info)" src="#"/>
				</td>
			</tr>
		</table>
		<div class="tooltip" id="tooltip_help_jcarousel_auto_integer">
			Specifies how many seconds to periodically autoscroll the content. If set to 0 (default) then autoscrolling is turned off. 
		</div>
		<div class="tooltip" id="tooltip_help_jcarousel_skin">
			Skin to apply for rendering of jcarousel
		</div>
		<div class="tooltip" id="tooltip_help_jcarousel_size">
			The size of the thumbnail image in the carousel in px.
		</div>
		<div class="tooltip" id="tooltip_help_jcarousel_width_carousel">
			The width of the carousel in px.
		</div>
		<div class="tooltip" id="tooltip_help_jcarousel_scroll">
			The number of items to scroll by.
		</div>';

		 return $ret;
	}

	function get_deco_start() {
		return sprintf('<ul id="gal_jcarou_%s" class="jcarousel-skin-%s">',$this->options['rdm_id'],$this->options['g3_jcarousel_skin']);
	}

	function get_deco_end() {
		return '</ul>';
	}

	function get_skins() {
		$dir = dirname( __FILE__ ) . '/skins';
		$skins = array();
		if(is_dir($dir)) {
			if ($dh = opendir($dir)) {
				while (($file = readdir($dh)) !== false) {
					if( $file == '.' || $file == '..' )
						continue;
					else {
						$filename = $dir.'/'.$file.'/';
						$class = $filename.'skin.css';
						if(is_dir($filename) && is_file($class) ) {
							$skins[sizeof($skins)] = $file;
						}
					}
				}
				closedir($dh);
			}
		}
		return $skins;
	}
}
?>
