<?php

/**
 * @package heiv-gallery_3
 * @author www.heiv.fr
 * @version 0.2.4
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.2.4
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010-2011 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

class heiv_gallery_3_render_single_img extends heiv_gallery_3_render {
	protected $pattern_css_photo = '';
	protected $pattern_js_gallery= '';

	function heiv_gallery_3_render_single_img($options=null,$attrs_=null) {

		$this->options = $options;

		extract(shortcode_atts(array(
			'target'=>'_blank',
			'width'=>100,
			'height'=>100,
			'direct_link' => $this->options['g3_directlink'] 
		), $attrs_));
		$this->options['g3_single_img_height']=trim($this->options['g3_single_img_height']);
		$this->options['g3_single_img_width']=trim($this->options['g3_single_img_width']);
		$this->options['g3_single_img_height'] = !is_numeric($height) ? $height : $this->options['g3_single_img_height'];
		$this->options['g3_single_img_width'] = !is_numeric($width) ? $width : $this->options['g3_single_img_width'];
	}

	function get_render_album($info) {
			$str='';
		if($this->options['g3_single_img_useThickBox']=='true') {
			$str = sprintf('<div class="hg3_s_si"><a rel="%4$s" href="%3$s" class="thickbox"><img src="%2$s" alt="%1$s"/></a><div><a href="%3$s" class="thickbox">%1$s</a></div></div>',
					$info->entity->title,
					$info->entity->thumb_url_public,
					$info->entity->resize_url_public,
					$this->options['rdm_id']
				);
		}
		else {
			if($this->options['g3_single_img_height']!='') {
				$style.=sprintf('height:%spx;',$this->options['g3_single_img_height']);
			}
			if($this->options['g3_single_img_width']!='') {
				$style.=sprintf('width:%dpx;',$this->options['g3_single_img_width']);
			}
			$str = sprintf('<div class="hg3_s_si"><img src="%2$s" alt="%1$s" style="%3$s"/></a><div>%1$s</div></div>',
					$info->entity->title,
					$info->entity->resize_url_public,
					$style
				);
		}
		return $str;
	}

	public function get_render_photo( $info ) {
		$str='';
		if($this->options['g3_single_img_useThickBox']=='true') {
			$str = sprintf('<div class="hg3_s_si"><a rel="%4$s" href="%3$s" class="thickbox"><img src="%2$s" alt="%1$s"/></a><div><a href="%3$s" class="thickbox">%1$s</a></div></div>',
					$info->entity->title,
					$info->entity->thumb_url_public,
					$info->entity->resize_url_public,
					$this->options['rdm_id']
				);
		}
		else {
			if($this->options['g3_single_img_height']!='') {
				$style.=sprintf('height:%spx;',$this->options['g3_single_img_height']);
			}
			if($this->options['g3_single_img_width']!='') {
				$style.=sprintf('width:%dpx;',$this->options['g3_single_img_width']);
			}
			$str = sprintf('<div class="hg3_s_si"><img src="%2$s" alt="%1$s" style="%3$s"/></a><div>%1$s</div></div>',
					$info->entity->title,
					$info->entity->resize_url_public,
					$style
				);
		}
		return $str;
	}

	function get_render($infos) {
		return parent::get_render($infos,$this->options);
	}

	function register_wp_css() {
		wp_enqueue_style('heiv_gallery_3_render_single_img', plugin_dir_url(__FILE__) . 'css/single_img.css');
		wp_enqueue_style('thickbox');
	}

	function register_wp_js () {
		wp_enqueue_script('thickbox');
	}

	function get_js_gallery() {
		return '';
		return sprintf( '
				<script type="text/javascript">
					function startGallery_%1$s() {
						$(\'gallery_%1$s\').className=\'gall\';
					}
					window.addEvent(\'domready\', startGallery_%1s);
				</script>'
				,$this->options['rdm_id']);
	}

	function get_css_photo() {
		return '';
	}
	public function get_form_conf () {
		return sprintf('
	 	<table class="form-table"> 
			<tr>
				<td>
					<label for="g3_single_img_height">Default height</label>
				</td>
				<td>
					<input name="g3_single_img_height" id="g3_single_img_height" type="text" value="%s" maxlength="99" size="40"/>
					<img id="help_single_img_height" class="ico_info" alt="(info)" src="#">
				</td>
			</tr>
			<tr>
				<td>
					<label for="g3_single_img_width">Default width</label>
				</td>
				<td>
					<input name="g3_single_img_width" id="g3_single_img_width" type="text" value="%s" maxlength="99" size="40"/>
					<img id="help_single_img_width" class="ico_info" alt="(info)" src="#">
				</td>
			</tr>
			<tr>
				<td>
					<label for="g3_single_img_useThickBox">Use ThickBox for displaying images</label>
				</td>
				<td>
					<select id="g3_single_img_useThickBox" name="g3_single_img_useThickBox">
						<option value="true" %s>%s</option>
						<option value="false" %s>%s</option>
					</select>
					<img id="help_single_img_use_thickbox" class="ico_info" alt="(info)" src="#">
			</tr>
		</table>
		<div class="tooltip" id="tooltip_help_single_img_height">
			The height by default for display a picture or a album in pixel (px).
		</div>
		<div class="tooltip" id="tooltip_help_single_img_width">
			The width by default for display a picture or a album in pixel (px).
		</div>
		<div class="tooltip" id="tooltip_help_single_img_use_thickbox">
			If "Yes" is selected, a thumb image is displayed, on clicking on it ThickBox displays the full sized image.
		</div>',
		$this->options['g3_single_img_height'],
		$this->options['g3_single_img_width'],
		($this->options['g3_single_img_useThickBox']=='true'?'selected="selected"':''), _('Yes'),
		($this->options['g3_single_img_useThickBox']=='false'?'selected="selected"':''), _('No')
		);
	}

}
?>
