<?php
/**
 * @package heiv-gallery_3
 * @author www.heiv.fr
 * @version 0.2.4
 */
/*
Plugin Name: heiv Gallery 3
Plugin URI: http://www.heiv.fr/wordpress/plugin/gallery3
Description: heiv-gallery_3 is a Wordpress Plug-in that embeds Gallery3 within Wordpress to share photos, videos and any other Gallery3 content seamlessly into the Wordpress Sidebar and Blog entries.
Version: 0.2.4
Author: heiv
Author URI: http://www.heiv.fr
License: GPL3

  Copyright 2010-2011 heiv  (email: moi@heiv.fr )

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 3, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

class heiv_gallery_3_render_smoothgallery extends heiv_gallery_3_render {

	protected $pattern_css_photo = '
		<script type="text/javascript">
			function startGallery_%1$s() {
				var height=%2$d;
				var width=%3$d;
				if(height)
					$(\'gallery_%1$s\').style.height=height+\'px\';
				if(width)
					$(\'gallery_%1$s\').style.width=width+\'px\';
			}
			window.addEvent(\'domready\', startGallery_%1s);
		</script>';

	protected $pattern_js_gallery= '
		<script type="text/javascript">
			function startGallery_%1$s() {
				var myGallery = new gallery($(\'gallery_%1$s\'), {
					timed: %2$s,
					delay: %3$s,
					showCarousel: %4$s,
					textShowCarousel: \'%5$s\',
					showInfopane: %6$s
				});
				var height=%7$d;
				var width=%8$d;
				$(\'gallery_%1$s\').style.height=height+\'px\';
				$(\'gallery_%1$s\').style.width=width+\'px\';
			}
			window.addEvent(\'domready\', startGallery_%1$s);
		</script>';

	protected $attrs=null;
	protected $options=null;

	function get_render_album($info) {
		return sprintf('
			<div class="imageElement" id="%1$s">
				<h3>&nbsp;%2$s</h3>
				<p>%4$s</p>
				<a href="%4$s" title="open image" class="open">&nbsp;</a>
				<img src="%5$s" class="thumbnail" alt="&nbsp;"/>
				<img src="%5$s" class="full" alt="&nbsp;"/>
			</div>
			',
				$info->entity->id,
				$info->entity->title,
				$info->entity->description,
				$this->options['g3_smoothgallery_directLink']=='true'?$info->entity->web_url:'#',
				isset($info->entity->thumb_url_public)?$info->entity->thumb_url_public:'#',
				$info->entity->tmp_id
		);
	}

	function get_render_photo($info) {
		$thumb = $info->entity->thumb_url_public!=''?sprintf('<img src="%s" class="thumbnail"/>',$info->entity->thumb_url_public):'';
		return sprintf('
			<div class="imageElement">
				<h3>%s</h3>
				<p>&nbsp;%s</p>
				<a href="%s" title="open image" class="open" target="%s">&nbsp;</a>
				<img src="%s" class="full" />
				%s
			</div>
			',	$info->entity->title,
				$info->entity->description,
				$this->options['g3_smoothgallery_directLink']=='true'?$info->entity->web_url:'#',
				$this->options['g3_smoothgallery_target'],
				$info->entity->resize_url_public,
				$thumb
		);
	}

	function get_css_photo() {
		return sprintf($this->pattern_css_photo,
			$this->options['rdm_id'],
			$this->options['g3_smoothgallery_height'],
			$this->options['g3_smoothgallery_width']);
	}

	function get_js_gallery() {
		return sprintf($this->pattern_js_gallery,
				$this->options['rdm_id'],
				$this->options['g3_smoothgallery_timed'],
				$this->options['g3_smoothgallery_delay'],
				$this->options['g3_smoothgallery_showCaroussel'],
				$this->options['g3_smoothgallery_textCaroussel'],
				$this->options['g3_smoothgallery_infoPane'],
				$this->options['g3_smoothgallery_height'],
				$this->options['g3_smoothgallery_width']);
	}

	function heiv_gallery_3_render_smoothgallery($options=array(),$attrs_=array()) {

		$this->options = $options;
		$this->attrs = $attrs_;
		if(!is_null($attrs_ ))
			foreach($attrs_ as $k=>$v)
				$attrs_[$k]=trim(strtolower($v));
		extract(shortcode_atts(
					array(
						'target_link_img'=>'_blank',
						'width' => $this->options['g3_smoothgallery_width'],
						'height' => $this->options['g3_smoothgallery_height'],
						'direct_link' => $this->options['g3_smoothgallery_directLink'],
						'timed' => $this->options['g3_smoothgallery_timed'],
						'delay' => $this->options['g3_smoothgallery_delay'],
						'text_caroussel' => $this->options['g3_smoothgallery_textCaroussel'],
						'info_pane' => $this->options['g3_smoothgallery_infoPane'],
						'show_caroussel' => $this->options['g3_smoothgallery_showCaroussel']
					), 
					$attrs_)
		);
		if( $target_link_img!='' ) {
			$this->options['g3_smoothgallery_target'] = $target_link_img;
		}
		$this->options['g3_smoothgallery_height'] = is_numeric($height) ? $height : $this->options['g3_smoothgallery_height'];

		$this->options['g3_smoothgallery_width'] = is_numeric($width)? $width : $this->options['g3_smoothgallery_width'];

		if($direct_link==='false' || $direct_link==='true' ) {
			$this->options['g3_smoothgallery_directLink'] = $direct_link;
		}
		else {
			if( !isset($this->options['g3_smoothgallery_directLink']) ){
				$this->options['g3_smoothgallery_directLink'] = false;
			}
		}
		if($show_caroussel==='false' || $show_caroussel==='true' ) {
			$this->options['g3_smoothgallery_showCaroussel'] = $show_caroussel;
		}
		else {
			if( !isset($this->options['g3_smoothgallery_showCaroussel']) ){
				$this->options['g3_smoothgallery_showCaroussel'] = false;
			}
		}
		if( $text_caroussel != '') {
			$this->options['g3_smoothgallery_textCaroussel'] = $text_caroussel;
		}

		if($infoPane==='false' || $infoPane==='true' ) {
			$this->options['g3_smoothgallery_infoPane'] = $infoPane;
		}
		else {
			if( !isset($this->options['g3_smoothgallery_infoPane']) ){
				$this->options['g3_smoothgallery_infoPane'] = false;
			}
		}

		if($timed==='false' || $timed==='true' ) {
			$this->options['g3_smoothgallery_timed'] = $timed;
		}
		else {
			if( !isset($this->options['g3_smoothgallery_timed']) ){
				$this->options['g3_smoothgallery_timed'] = false;
			}
		}

		$this->options['g3_smoothgallery_delay'] = is_numeric($delay) ? $delay : $this->options['g3_smoothgallery_delay'];
	}

	function get_render($infos) {
		return parent::get_render($infos,$this->options);
	}
	
	public function register_wp_css() {
		wp_enqueue_style('jd_gallery', plugin_dir_url(__FILE__) . 'jd.gallery.css');
	}

	public function register_wp_js() {
		wp_register_script( 'mootools', plugin_dir_url(__FILE__) . 'js/mootools.v1.11.js');
		wp_register_script( 'jd_gallery', plugin_dir_url(__FILE__) . 'js/jd.gallery.js',array('mootools'));
		wp_enqueue_script('mootools');
		wp_enqueue_script('jd_gallery');
	}

	public function get_form_conf () {
		return sprintf('
				<table class="form-table"> 
					<tr>
						<td>
							<label for="g3_smoothgallery_height">Default height</label>
						</td>
						<td>
							<input name="g3_smoothgallery_height" id="g3_smoothgallery_height" type="text" value="%s" maxlength="99" size="40"/>
							<img id="help_smoothgallery_height" class="ico_info" alt="(info)" src="#">
						</td>
					</tr>
					<tr>
						<td>
							<label for="g3_smoothgallery_width">Default width</label>
						</td>
						<td>
							<input name="g3_smoothgallery_width" id="g3_smoothgallery_width" type="text" value="%s" maxlength="99" size="40"/>
							<img id="help_smoothgallery_width" class="ico_info" alt="(info)" src="#">
						</td>
					</tr>
					<tr>
                                                <td>
                                                        <label for="g3_smoothgallery_textCaroussel">Text of the Caroussel </label>
                                                </td>
                                                <td>
                                                        <input name="g3_smoothgallery_textCaroussel" id="g3_smoothgallery_textCaroussel" type="text" value="%s" maxlength="99" size="40"/>
							<img id="help_smoothgallery_textCarousel" class="ico_info" alt="(info)" src="#">
                                                </td>
                                        </tr>
					<tr>
                                                <td>
                                                        <label for="g3_smoothgallery_showCaroussel">Show the Caroussel </label>
                                                </td>
                                                <td>
							<select id="g3_smoothgallery_showCaroussel" name="g3_smoothgallery_showCaroussel">
								<option value="true" %s>%s</option>
								<option value="false" %s>%s</option>
							</select>
							<img id="help_smoothgallery_showCarousel" class="ico_info" alt="(info)" src="#">
                                                </td>
                                        </tr>
					<tr>
                                                <td>
                                                        <label for="g3_smoothgallery_infoPane">Image information panel</label>
                                                </td>
                                                <td>
							<select id="g3_smoothgallery_infoPane" name="g3_smoothgallery_infoPane">
								<option value="true" %s>%s</option>
								<option value="false" %s>%s</option>
							</select>
							<img id="help_smoothgallery_infoPane" class="ico_info" alt="(info)" src="#">
                                                </td>
                                        </tr>
                                        <tr>
                                                <td>
                                                        <label for="g3_smoothgallery_timed">Timed caroussel </label>
                                                </td>
                                                <td>
							<select id="g3_smoothgallery_timed" name="g3_smoothgallery_timed">
								<option value="true" %s>%s</option>
								<option value="false" %s>%s</option>
							</select>
							<img id="help_smoothgallery_timed" class="ico_info" alt="(info)" src="#">
                                                </td>
                                        </tr>
                                        <tr>
                                                <td>
                                                        <label for="g3_smoothgallery_delay">delay for Timed caroussel </label>
                                                </td>
                                                <td>
                                                        <input name="g3_smoothgallery_delay" id="g3_smoothgallery_delay" type="text" value="%s" maxlength="99" size="40" />
							<img id="help_smoothgallery_delay" class="ico_info" alt="(info)" src="#">
                                                </td>
                                        </tr>
       					<tr>
						<td>
							<label for="g3_smoothgallery_directLink">Direct link to gallerys / pictures</label>
						</td>
						<td>
							<select id="g3_smoothgallery_directLink" name="g3_smoothgallery_directLink">
								<option value="true" %s>%s</option>
								<option value="false" %s>%s</option>
							</select>
							<img id="help_smoothgallery_directLink" class="ico_info" alt="(info)" src="#">
					</tr>
					<tr>
						<td>
							<label for="g3_smoothgallery_target">Target of the Direct link to gallerys / pictures</label>
						</td>
						<td>
							<select id="g3_smoothgallery_target" name="g3_smoothgallery_target">
								<option %s value="_blank">_blank</option>
								<option %s value="_parent">_parent</option>
								<option %s value="_self">_self</option>
							</select> 
							<img id="help_smoothgallery_target" class="ico_info" alt="(info)" src="#">
						</td>
					</tr>
				</table>
				<div class="tooltip" id="tooltip_help_smoothgallery_height">
					The height by default for display a picture or a album in pixel (px).
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_width">
					The width by default for display a picture or a album in pixel (px).
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_textCarousel">
					Text of the caroussel
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_showCarousel">
					If showCaroussel is Yes the caroussel is visible.
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_infoPane">
					Show or hide the image information panel
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_timed">
					If timed is Yes the picture will change automaticly
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_delay">
					delay is milliseconds
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_directLink">
					Option which allow a visitor to go on the Gallery3 site
				</div>
				<div class="tooltip" id="tooltip_help_smoothgallery_target">
					Open picture or album Gallery3 site :
					<ul style="list-style: disc inside none;">
						<li> _self => in the current page</li>
						<li> _parent => in the parent page of the current page</li>
						<li> _blank => in a new page</li>
					</ul>
				</div>',
				$this->options['g3_smoothgallery_height'],
				$this->options['g3_smoothgallery_width'],
				$this->options['g3_smoothgallery_textCaroussel'],
				$this->options['g3_smoothgallery_showCaroussel']=='true'? 'selected="selected" ':'', _('Yes'),
				$this->options['g3_smoothgallery_showCaroussel']=='false'? 'selected="selected" ':'', _('No'),
				$this->options['g3_smoothgallery_infoPane']=='true'? 'selected="selected" ':'', _('Yes'),
				$this->options['g3_smoothgallery_infoPane']=='false'? 'selected="selected" ':'', _('No'),
				$this->options['g3_smoothgallery_timed']=='true'? 'selected="selected" ':'', _('Yes'),
				$this->options['g3_smoothgallery_timed']=='false'? 'selected="selected" ':'', _('No'),
				$this->options['g3_smoothgallery_delay'],
				$this->options['g3_smoothgallery_directLink']=='true'? 'selected="selected" ':'', _('Yes'),
				$this->options['g3_smoothgallery_directLink']=='false'? 'selected="selected" ':'', _('No'),


				$this->options['g3_smoothgallery_target']=='true'? 'selected="selected" ':'', 
				$this->options['g3_smoothgallery_target']=='false'? 'selected="selected" ':'',
				$this->options['g3_smoothgallery_target']=='false'? 'selected="selected" ':''

		);
	}
}
?>
